import processing.core.*; 
import processing.xml.*; 

import javax.swing.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class SoundTxtMaker extends PApplet {

//Java\u306eSwing\u3092\u53d6\u308a\u8fbc\u3080


//\u753b\u50cf\u30a4\u30f3\u30b9\u30bf\u30f3\u30b9\u3092\u7528\u610f 
PImage pimage;

int ww =5000;
int hh =3000;

//\u9078\u629e\u30d5\u30a1\u30a4\u30eb\u3092\u7528\u610f\u3057
//\u30d5\u30a1\u30a4\u30eb\u3092\u7a7a\u306b\u3057\u3066\u304a\u304f
String getFile = null;
float[] kuro = new float[ww];
String[] kurotxt = new String[ww];
int c;
int tate=0;
boolean ready = false; 


public void setup() {

//\u3068\u308a\u3042\u3048\u305a\u8868\u793a\u753b\u9762\u3092hh*0.5\u89d2\u306b\u8a2d\u5b9a 
  size(ww, hh); 
  background(255);
}

public void draw() {

  stroke(200);
  line(0, hh/2, ww, hh/2);
  //\u9078\u629e\u30d5\u30a1\u30a4\u30eb\u540d\u304c\u7a7a\u3067\u306a\u3044\u3068\u304d
  if (getFile != null) {
    //\u30d5\u30a1\u30a4\u30eb\u3092\u53d6\u308a\u8fbc\u3080
    fileLoader();
  } 



  if (ready) {
    for (int w=0; w<ww; w++) {
      kuro[w]=hh;
      for (int v=hh; v>0; v--) {

        if (get(w, v) ==color(0)) {

          kuro[w]=v;
        }

      }
      fill(255, 0, 0); 
      stroke(255, 0, 0);
      ellipse(w, kuro[w], 2, 2);
    }
    ready = false;
    for (int w=0; w<ww; w++) {    
      kuro[w]=(-1.25f+kuro[w]/hh*3);

      if (kuro[w]==1.75f) {
        kuro[w]=0;
      }
      println(kuro[w]);
      kurotxt[w] = str(kuro[w]);
    }


    saveStrings("sound.txt", kurotxt);
  }
}

//\u30de\u30a6\u30b9\u3092\u62bc\u3057\u305f\u3089
public void mousePressed() {
  //\u9078\u629e\u30d5\u30a1\u30a4\u30eb\u53d6\u5f97\u51e6\u7406 
  getFile = getFileName();
}

//\u30d5\u30a1\u30a4\u30eb\u3092\u53d6\u308a\u8fbc\u3080\u30d5\u30a1\u30f3\u30af\u30b7\u30e7\u30f3 
public void fileLoader() {
  //\u9078\u629e\u30d5\u30a1\u30a4\u30eb\u30d1\u30b9\u306e\u30c9\u30c3\u30c8\u4ee5\u964d\u306e\u6587\u5b57\u5217\u3092\u53d6\u5f97
  String ext = getFile.substring(getFile.lastIndexOf('.') + 1);
  //\u305d\u306e\u6587\u5b57\u5217\u3092\u5c0f\u6587\u5b57\u306b\u3059\u308b
  ext.toLowerCase();
  //\u6587\u5b57\u5217\u672b\u5c3e\u304cjpg,png,gif,tga\u306e\u3044\u305a\u308c\u304b\u3067\u3042\u308c\u3070 
  if (ext.equals("jpg") || ext.equals("png") ||  ext.equals("gif") || ext.equals("tga")) {
    //\u9078\u629e\u30d5\u30a1\u30a4\u30eb\u30d1\u30b9\u306e\u753b\u50cf\u3092\u53d6\u308a\u8fbc\u3080
    pimage = loadImage(getFile);
    //\u30a4\u30e1\u30fc\u30b8\u8868\u793a 
    image(pimage, 0, 0, pimage.width, pimage.height);
  }
  //\u9078\u629e\u30d5\u30a1\u30a4\u30eb\u30d1\u30b9\u3092\u7a7a\u306b\u623b\u3059
  getFile = null;
  ready = true;
}

//\u30d5\u30a1\u30a4\u30eb\u9078\u629e\u753b\u9762\u3001\u9078\u629e\u30d5\u30a1\u30a4\u30eb\u30d1\u30b9\u53d6\u5f97\u306e\u51e6\u7406 
public String getFileName() {
  //\u51e6\u7406\u30bf\u30a4\u30df\u30f3\u30b0\u306e\u8a2d\u5b9a 
  SwingUtilities.invokeLater(new Runnable() { 
    public void run() {
      try {
        //\u30d5\u30a1\u30a4\u30eb\u9078\u629e\u753b\u9762\u8868\u793a 
        JFileChooser fc = new JFileChooser(); 
        int returnVal = fc.showOpenDialog(null);
        //\u300c\u958b\u304f\u300d\u30dc\u30bf\u30f3\u304c\u62bc\u3055\u308c\u305f\u5834\u5408
        if (returnVal == JFileChooser.APPROVE_OPTION) {
          //\u9078\u629e\u30d5\u30a1\u30a4\u30eb\u53d6\u5f97 
          File file = fc.getSelectedFile();
          //\u9078\u629e\u30d5\u30a1\u30a4\u30eb\u306e\u30d1\u30b9\u53d6\u5f97 
          getFile = file.getPath();
        }
      }
      //\u4e0a\u8a18\u4ee5\u5916\u306e\u5834\u5408 
      catch (Exception e) {
        //\u30a8\u30e9\u30fc\u51fa\u529b 
        e.printStackTrace();
      }
    }
  } 
  );
  //\u9078\u629e\u30d5\u30a1\u30a4\u30eb\u30d1\u30b9\u53d6\u5f97
  return getFile;
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "SoundTxtMaker" });
  }
}
